#include <iostream> 
using namespace std;

class Point {
private:
	int x, y;
public:
	Point(int _x = 0, int _y = 0) :x(_x), y(_y) {}
	Point(const Point &p) {
		cout << "Point(const Point &p) ȣ :  x = " << p.x << ",  y = " << p.y << endl;
		x = p.x;
		y = p.y;
	}
	void ShowPosition();
	Point operator+(const Point &p);
};

void Point::ShowPosition() {
	cout << x << "  " << y << endl;
}

Point Point::operator+(const Point &p) {
	Point temp(x + p.x, y + p.y);
	return temp;
}

int main() {
	Point p1(1, 2);
	Point p2(2, 3);

	Point p3 = p1 + p2;   
	// Point p3 = p1.operator+(p2);  <- Operator 
	// Point p3 = '  temp ü'  <-   ȣ
	
	p3.ShowPosition();
}