#include <iostream>
#include <string>	
using namespace std;

class Point {
private:
	int x, y;
public:
	Point(int a = 0, int b = 0) {
		x = a, y = b;
	}
	int getX() {
		return x;
	}
	int getY() {
		return y;
	}
	void showPos() {
		cout << "x=" << x << ", y=" << y << endl;
	}

	Point operator+(Point src) {  // ε
		Point p;
		p.x = this->x + src.x;
		p.y = this->y + src.y;
		cout << "p.x=" << p.x << ", p.y=" << p.y << endl;
		return p;
	}
	friend Point operator+(int src, Point &src1); // friend Ű
};

Point operator+(int src, Point &src1) {  // ε
	Point p(src1.x + src, src1.y + src); 
	// x, y private ̹Ƿ friend Ű尡 ٸ ERROR
	return p;
}

int main() {
	Point p1(10, 20);
	Point p2(5, 6);
	Point p3 = p1 + p2; // p.x=15, p.y=26
	p2 = p2.operator+(p1); // p.x=15, p.y=26
	p1.showPos(); // x=10, y=20
	p2.showPos(); // x=15, y=26
	p3.showPos(); // x=15, y=26

	Point a1(100, 200);
	Point a2;
	a2 = a1 + 99; // p.x=199, p.y=200
	a2.showPos(); // x=199, y=200
}