#include <iostream>
using namespace std;

class Point {
	int xp, yp;
public:
	Point() { xp = yp = 0; }  // 1
	Point(int x, int y) { xp = x, yp = y; } // 2
	void get_xy(int &x, int &y) { x = xp; y = yp; }
	Point operator +(Point ob);  // +  ߺ
	Point operator -(Point ob);  // -  ߺ
};

Point Point::operator +(Point ob) {
	Point tmp;
	tmp.xp = xp + ob.xp;  // this->xp + ob.xp
	tmp.yp = yp + ob.yp;  // this->yp + ob.yp
	return tmp;
}

Point Point::operator -(Point ob) {
	Point tmp;
	tmp.xp = xp - ob.xp;  // this->xp - ob.xp
	tmp.yp = yp - ob.yp;  // this->yp - ob.yp
	return tmp;
}

int main() {
	Point p, p1, p2(10, 20), p3(100, 200), p4(5, 5);
	int x, y;
	p = p2 + p3 + p4;  // +  Լ ȣ
	p.get_xy(x, y);
	cout << "[ p = p2 + p3 + p4] x : " << x
		<< " , y : " << y << endl;

	p1 = p2 - p3 - p4;  // -  Լ ȣ
	p1.get_xy(x, y);
	cout << "\n[ p1 = p2 - p3 - p4] x : " << x
		<< " , y : " << y << endl;
}