#include <iostream>
using namespace std;

class Point {
private:
	int xpos, ypos;
public:
	Point(int x = 0, int y = 0) : xpos(x), ypos(y) {}
	friend ostream& operator<<(ostream& os, const Point& pos);

	static void * operator new(size_t size) {
		void * adr = new char[size];
		return adr;
	}

	static void operator delete(void * adr) {
		delete[] adr;
	}
};

ostream& operator<<(ostream& os, const Point& pos) {
	os << '[' << pos.xpos << ", " << pos.ypos << ']' << endl;
	return os;
}

int main() {
	Point * ptr = new Point(5, 6);
	cout << *ptr;
	delete ptr;
}