#define _CRT_SECURE_NO_WARNINGS 
#include <iostream>
#include <string>
using namespace std;

class String {
	char *str;
	int len;
public:
	String();   // 
	String(const char * const Str);  // 
	String(int n);   // 
	String(const String &);     // 
	~String();     // Ҹ
	void Print();  // ڿ ȭ鿡 
	int GetLen() { return len; }  // ڿ ũ⸦ ȯ
	char *GetString() { return str; }  // ڿ ȯ
	String operator = (String data);  //   ε
	String operator+(const String &second);  //   ε
};

String::String() {
	str = NULL;
	len = 0;
}

String::~String() {
	if (str)
		delete str;
}

String::String(int n) {
	len = n;
	str = new char[len + 1];
	memset(str, '\0', len); // 迭 ʱȭ
}

String::String(const char * const Str) {
	len = strlen(Str);
	str = new char[len + 1];
	strcpy(str, Str);
}

String::String(const String &temp) {
	len = temp.len;
	str = new char[len + 1];
	strcpy(str, temp.str);
}

void String::Print() {
	cout << str << endl;
}

String String::operator = (String data) {
	len = data.GetLen();  // dataü  ڿ ũ⸦ ˰
	str = new char[len + 1];  //  ũ⸸ŭ ޸𸮸 Ҵ 
	strcpy(str, data.GetString());  // dataü ڿ 
	return *this;  //  ü ȯ
}

String String::operator+(const String &second) { // +  ε
	int tot_len = len + second.len; 	//  ڿ ̸ 
	//  ڿ    ũ stringü 
	String temp(tot_len);
	strcpy(temp.str, str);           // ü ڿ ӽ ü 
	strcat(temp.str, second.str);  //  ü ڿ ӽ ü ߰
	return temp; 	// ӽ ü  ȯ
}

int main() {
	cout << " ڿ + ϱ\n";
	String str1("C++ ");
	String str2("α׷!!");
	String str3;
	str3 = str1 + str2;
	cout << "ڿ1 :";	str1.Print();
	cout << "ڿ2 :";	str2.Print();
	cout << "-------------------------\n";
	cout << "[ڿ1 + ڿ2] => "; str3.Print();
}