#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
using namespace std;

class String {
	char *str;
	int len;
public:
	String();   // 
	String(const char * const Str);  // 
	String(int n);   // 
	String(const String &);     // 
	~String();     // Ҹ
	void Print();  // ڿ ȭ鿡 
	void GetInput();  // ڿ ֿܼ Է
	int GetLen() { return len; }  // ڿ ũ⸦ ȯ
	char *GetString() { return str; }  // ڿ ȯ
	String operator = (String data);  //   ε
	String operator += (String data);  //   ε
	String operator+(const String &second);  //   ε
	operator const char* ()
	{
		return str;
	};  // const char*  ε
	friend ostream & operator
		<<(ostream &os, String &temp); // <<  ε
	char operator [](int n);  // ÷ ġ   ˸
};

String::String() {
	str = NULL;
	len = 0;
}

String::~String() {
	if (str)
		delete str;
}

String::String(int n) {
	len = n;
	str = new char[len + 1];
	memset(str, '\0', len);
}

String::String(const char * const Str) {
	len = strlen(Str);
	str = new char[len + 1];
	strcpy(str, Str);
}

String::String(const String &temp) {
	len = temp.len;
	str = new char[len + 1];
	strcpy(str, temp.str);
}

void String::Print() {
	cout << str << endl;
}

void String::GetInput() {
	char temp[80];
	cin >> temp;
	len = strlen(temp);
	str = new char[len + 1];
	strcpy(str, temp);
}

String String::operator = (String data) {
	len = data.GetLen();  // dataü  ڿ ũ⸦ ˰
	str = new char[len + 1];  //  ũ⸸ŭ ޸𸮸 Ҵ 
	strcpy(str, data.GetString());  // dataü ڿ 
	return *this;  //  ü ȯ
}

String String::operator += (String data) {
	char temp[512];
	strcpy(temp, str);  //  ͸ temp ϰ
	len += data.GetLen();  //  ũ⿡ dataü ڿ ũ⸸ŭ ߰
	str = new char[len + 1];  //  str ޸𸮿 Ҵ
	strcpy(str, temp);  // temp ϰ
	strcat(str, data.GetString());  // dataü ڿ 
	return *this;  //  ڿ ȯ
}

String String::operator+(const String &second) { // +  ε
	int tot_len = len + second.len; 	//  ڿ ̸ 
		//  ڿ    ũ stringü 
	String temp(tot_len);
	strcpy(temp.str, str); 	//  ü ڿ ӽ ü 
	strcat(temp.str, second.str); //  ü ڿ ӽ ü ߰
	return temp; 	// ӽ ü  ȯ
}

ostream & operator << (ostream &os, String &temp) {
	os << temp.str;
	return os;
}

char String::operator [](int n) {  // ÷ ġ  
	//  ÷ڰ ڿ ̺ ũ
	if (n > len)
		return str[len - 1];
	else
		return str[n];
}

int main() {
	String *data1 = new String;
	String *data2 = new String;

	cout << " ڿ += ϱ\n";
	cout << "ڿ1 :";
	data1->GetInput();  // data ڿ Է
	cout << "ڿ2 :";
	data2->GetInput();  // data2 ڿ Է
	cout << "-------------------------" << endl;
	*data1 += *data2;   // *data.operator(String *data2) · ȣ
	cout << "[ڿ1 += ڿ2] => ";
	data1->Print();    //  ڿ ü data 
	cout << "\nchar*   : ";
	cout << data1->operator const char*() << endl;  // char* 

	cout << "\n==========================" << endl;
	cout << " ڿ + ϱ\n";
	String str1("C++ ");
	String str2("α׷!!");
	String str3 = str1 + str2;
	cout << "ڿ1 :";	str1.Print();
	cout << "ڿ2 :";	str2.Print();
	cout << "-------------------------\n";
	cout << "[ڿ1 + ڿ2] => "; str3.Print();
}