#include <iostream>
using namespace std;

class A {
	int a;
public:
	A() 	{}
	A(int a) {
		this->a = a;
	}
	void dispA() 	{
		cout << a << endl;
	}
};

class B :virtual public A {
	int b;
public:
	B() :A::A() { 	}
	B(int a = 0, int b = 0) :A::A(a) {
		this->b = b;
	}
	void dispB() 	{
		cout << b << endl;
	}
};

class C :public virtual A {    // virtual ġ 
	int c;
public:
	C() :A::A() { 	}
	C(int a = 0, int c = 0) :A::A(a) 	{
		this->c = c;
	}
	void dispC() {
		cout << c << endl;
	}
};

class D :public B, public C {
	int d;
public:
	D(int a = 0, int b = 0, int c = 0, int d = 0) :B::B(a, b), C::C(a, c), A::A(a) 	{
		this->d = d;
	}
	void dispD() {
		cout << d << endl;
	}
};

int main() {
	D dd(1, 2, 3, 4);

	dd.dispD();
	dd.dispC();
	dd.dispB();
	dd.dispA();
}