#include <iostream>
#include <string>
using namespace std;

class Array {
	int *iPtr;
	int size;
public:
	Array(int sz = 10) {
		if (sz <= 0) //  ÷ ũⰡ 0  
			throw SmallError();
		if (sz > 10) // ÷ ũⰡ 10 Ŭ 
			throw BigError();
		iPtr = new int[sz];
		*iPtr = 0;
		size = sz;
	}
	int getsize() {
		return size;
	}
	int & operator [ ] (int sz) {
		if (sz < 0 || sz > getsize())
			throw SizeError(); // ÷    ߻
		return iPtr[sz];
	}
	class SizeError { };
	class BigError : public SizeError { };
	class SmallError : public SizeError { };
};

int main() {
	try {
		Array arr(5); // ÷ ũⰡ ũų   ܰ ߻
		for (int i = 0; i < 5; i++) {
			arr[i] = i + 1; // ÷   ܰ ߻
			cout << "array[" << i << "] = " << arr[i] << endl;
		}
		arr[6] = 11; // Size Error  ߻
	}
	catch (Array::BigError) {
		cerr << "迭 ʹ Ůϴ!!" << endl;
	}
	catch (Array::SmallError) {
		cerr << "迭 ʹ ϴ!!" << endl;
	}
	catch (Array::SizeError) {
		cerr << "迭 Ѱ谡 Ѿ    ϴ!!" << endl;
	}
	catch (...) {
		cerr << "迭 !!" << endl;
	}
}