#include <iostream>
#include <iomanip>  // Ʈ ۱⸦ ϱ ( setw() )
#include <set> 
#include <iterator> 
using namespace std;

int main() {
	// set 
	set <int, greater <int> > set1;

	//   ߰
	set1.insert(40);
	set1.insert(30);
	set1.insert(60);
	set1.insert(20);
	set1.insert(50);
	set1.insert(50); // 50 ߰
	set1.insert(10);

	//set1 set 
	set <int, greater <int> > ::iterator itr;
	cout << "set1  : ";
	for (itr = set1.begin(); itr != set1.end(); ++itr) {
		cout <<setw(5) << *itr;
	}
	cout << endl;

	// set1 set2  
	set <int> set2(set1.begin(), set1.end());

	//set2 
	cout << "\nset1  set2  : ";
	for (itr = set2.begin(); itr != set2.end(); ++itr) {
		cout << setw(5) << *itr;
	}
	cout << endl;

	// set2 30   
	cout << "\nset2 30    : ";
	set2.erase(set2.begin(), set2.find(30));
	for (itr = set2.begin(); itr != set2.end(); ++itr) {
		cout << setw(5) << *itr;
	}

	// set2 50  
	int num;
	num = set2.erase(50);
	cout << "\nset2.erase(50) : ";
	cout << num << " ŵǾ!! : ";
	for (itr = set2.begin(); itr != set2.end(); ++itr) 	{
		cout << setw(5) << *itr;
	}

	cout << endl;

	// set1 Ư ڷ 
	cout << "\nset1.lower_bound(40) : "
		<< *set1.lower_bound(40) << endl;
	cout << "set1.upper_bound(40) : "
		<< *set1.upper_bound(40) << endl;

	// set2 Ư ڷ 
	cout << "\nset2.lower_bound(40) : "
		<< *set2.lower_bound(40) << endl;
	cout << "set2.upper_bound(40) : "
		<< *set2.upper_bound(40) << endl;
}