#include <iostream>
#include <cstring>

using namespace std;

class Person {
private:
	char* name;
	int age;
public:
	Person(const char myname[], int myage) 	{
		int len = strlen(myname) + 1;
		name = new char[len];
		strcpy_s(name, len, myname);   
		age = myage;
	}
	Person(const Person& copy) : age(copy.age) 	{
		int len = strlen(copy.name) + 1;
		name = new char[len];
		strcpy_s(name, len, copy.name);  
	}
	void ShowPersonInfo() const 	{
		cout << "̸: " << name << endl;
		cout << ": " << age << endl;
	}
};

int main() {
	Person man1("ȫ浿", 14);
	Person man2 = man1;  
	man1.ShowPersonInfo();
	man2.ShowPersonInfo();
}
