#define _CRT_SECURE_NO_WARNINGS 
#include <iostream>
#include <string>
using namespace std;

class Students {
	char *Stdno;
	char *Name;
	int Age;
public:
	Students(const char *, const char *, const int &);
	void print() const;
	class InvalidErrorStdno { };	//  Ŭ
	class InvalidErrorName { };	//  Ŭ
	class InvalidErrorAge { };	//  Ŭ
};
Students::Students(const char *S, const char *N, const int &A) {
	Stdno = new char[strlen(S) + 1];
	strcpy(Stdno, S);
	Name = new char[strlen(N) + 1];
	strcpy(Name, N);
	Age = A;
}

inline void Students::print() const {
	if (Stdno == NULL)
		throw InvalidErrorStdno();
	cout << "й : " << Stdno << endl;
	if (Name == NULL)
		throw InvalidErrorName();
	cout << "̸ : " << Name << endl;
	if (Age <= 0)
		throw InvalidErrorAge();
	cout << " : " << Age << "\n\n";
}

int main() {
	try {
		Students std1("05111001", "", 20), std2("04111220", "", 0);
		std1.print();
		std2.print();
	}
	catch (Students::InvalidErrorStdno) {
		cout << "й  !" << endl;
	}
	catch (Students::InvalidErrorName) {
		cout << "̸  !" << endl;
	}
	catch (Students::InvalidErrorAge) {
		cout << "  !" << endl;
	}
	cout << endl;
}